package it.eng.spagobi.presentation.tags;

import it.eng.spago.base.Constants;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spagobi.utilities.PortletUtilities;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class QueryWizardTag extends TagSupport {

	private String connectionName;
	private String visibleColumns;
	private String valueColumns;
	private String queryDef;
	
	public int doStartTag() throws JspException {
		TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "QueryWizardTag::doStartTag:: invocato");

		StringBuffer output = new StringBuffer();
		output.append("<table class='object-details-table'>\n");
		output.append("	<tr height='25'>\n");
		String connNameField = PortletUtilities.getMessage("SBIDev.queryWiz.connNameField", "messages");
		output.append("		<td align='right' class='portlet-form-field-label' >"+ connNameField + "</td>\n");
		output.append("		<td>&nbsp;</td>\n");
	    output.append("		<td><input class='portlet-form-input-field' type='text' name='connName' size='50' value='"+ connectionName + "' maxlength='100'>&nbsp;*</td>\n");
	    output.append("	</tr>\n");
		output.append("	<tr height='25'>\n");
		String visColumnsField = PortletUtilities.getMessage("SBIDev.queryWiz.visColumnsField", "messages");
		output.append("		<td align='right' class='portlet-form-field-label' >" + visColumnsField + "</td>\n");
		output.append("		<td>&nbsp;</td>\n");
	    output.append("		<td><input class='portlet-form-input-field' type='text' name='visColumns' size='50' value='"+ visibleColumns + "' maxlength='100'>&nbsp;*</td>\n");
	    output.append("	</tr>\n");
		output.append("	<tr height='25'>\n");
		String valueColumnsField = PortletUtilities.getMessage("SBIDev.queryWiz.valueColumnsField", "messages");
		output.append("		<td align='right' class='portlet-form-field-label' >" + valueColumnsField + "</td>\n");
		output.append("		<td>&nbsp;</td>\n");
	    output.append("		<td><input class='portlet-form-input-field' type='text' name='valueColumns' size='50' value='"+ valueColumns + "' maxlength='100'>&nbsp;*</td>\n");
	    output.append("	</tr>\n");
		output.append("	<tr height='25'>\n");
		String queryDefField = PortletUtilities.getMessage("SBIDev.queryWiz.queryDefField", "messages");
		output.append("		<td align='right' class='portlet-form-field-label' >" + queryDefField + "</td>\n");
		output.append("		<td>&nbsp;</td>\n");
	    output.append("		<td><textarea class='portlet-text-area-field' name='queryDef' rows='5' cols='50'>" + queryDef + "</textarea></td>\n");
	    output.append("	</tr>\n");
	    output.append("</table>\n");
	    
        try {
            pageContext.getOut().print(output.toString());
        }
        catch (Exception ex) {
            TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.CRITICAL, "QueryWizardTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        }
	    
		return SKIP_BODY;
	}
	
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "QueryWizardTag::doEndTag:: invocato");
        return super.doEndTag();
    }
	
	public String getConnectionName() {
		return connectionName;
	}
	public void setConnectionName(String connectionName) {
		this.connectionName = connectionName;
	}
	public String getQueryDef() {
		return queryDef;
	}
	public void setQueryDef(String queryDef) {
		this.queryDef = queryDef;
	}
	public String getValueColumns() {
		return valueColumns;
	}
	public void setValueColumns(String valueColumns) {
		this.valueColumns = valueColumns;
	}
	public String getVisibleColumns() {
		return visibleColumns;
	}
	public void setVisibleColumns(String visibleColumns) {
		this.visibleColumns = visibleColumns;
	}
	
}
