/**

SpagoBI - The Business Intelligence Free Platform

Copyright (C) 2005 Engineering Ingegneria Informatica S.p.A.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spagobi.services.modules;

import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.security.IEngUserProfile;
import it.eng.spagobi.constants.ObjectsTreeConstants;
import it.eng.spagobi.utilities.PortletUtilities;


public class DashboardModule extends AbstractModule
{
	
	public void init(SourceBean config) {
	}
	
	

	public void service(SourceBean request, SourceBean response) throws Exception {
		RequestContainer requestContainer = this.getRequestContainer();
		PortletRequest portReq = PortletUtilities.getPortletRequest();
		PortletPreferences pref = portReq.getPreferences();
		String movie = pref.getValue("movie", "");
		String dataurl = pref.getValue("dataurl", "");
		String width = pref.getValue("width", "");
		String height = pref.getValue("height", "");
		String title = pref.getValue("title", "");
		response.setAttribute("movie", movie);
		response.setAttribute("dataurl", dataurl);
		response.setAttribute("width", width);
		response.setAttribute("height", height);
		response.setAttribute("title", title);
	}

}
