package it.eng.spago.base;

import java.util.Locale;

import javax.portlet.PortletConfig;
import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;

public class PortletAccess {

	static ThreadLocal portletRequest = new ThreadLocal(); 
	static ThreadLocal portletResponse = new ThreadLocal(); 
	static ThreadLocal portletConfig = new ThreadLocal();
	static ThreadLocal browserLocale = new ThreadLocal();
	static ThreadLocal portalLocale = new ThreadLocal();
	
	
	static public void setPortletRequest(PortletRequest req) {
		portletRequest.set(req);
	}
	
	static public void setPortletResponse(PortletResponse resp) {
		portletResponse.set(resp);
	}
	
	static public void setBrowserLocale(Locale local) {
		browserLocale.set(local);
	}
	
	static public void setPortalLocale(Locale local) {
		portalLocale.set(local);
	}
	
	static public void setPortletConfig(PortletConfig conf) {
		portletConfig.set(conf);
	}


	
	static public PortletRequest getPortletRequest() {
		PortletRequest request = null;
		try{
			request = (PortletRequest)portletRequest.get();
		} catch(Exception e) {
			// ignore
		}
		return request;
	}
	
	static public PortletResponse getPortletResponse() {
		PortletResponse response = null;
		try {
			response = (PortletResponse)portletResponse.get(); 
		} catch (Exception e) {
			// ignore
		}
		return response;
	}
	
	
	
	static public PortletConfig getPortletConfig() {
		PortletConfig config = null;
		try {
			config = (PortletConfig)portletConfig.get();
		} catch (Exception e) {
			// ignore
		}
		return config;
	}
	
	
	static public Locale getBrowserLocale() {
		Locale locale = null;
		try {
			locale = (Locale)browserLocale.get();
		} catch (Exception e) {
			// ignore
		}
		return locale;
	}
	
	
	
	static public Locale getPortalLocale() {
		Locale locale = null;
		try {
			locale = (Locale)portalLocale.get();
		} catch (Exception e) {
			// ignore
		}
		return locale;
	}
	

}
	





