package it.eng.spago.cms.exec.entities;

import it.eng.javax.jcr.Value;
import it.eng.javax.jcr.ValueFactory;
import it.eng.spago.cms.exceptions.ValueCastException;
import it.eng.spago.cms.util.constants.ModuleConstants;
import it.eng.spago.cms.util.constants.PropertiesConstants;
import it.eng.spago.tracing.TracerSingleton;

import java.io.InputStream;
import java.util.Calendar;
import java.util.Vector;

//import it.eng.javax.jcr.BinaryValue;
//import it.eng.javax.jcr.BooleanValue;
//import it.eng.javax.jcr.DateValue;
//import it.eng.javax.jcr.DoubleValue;
//import it.eng.javax.jcr.LongValue;
//import it.eng.javax.jcr.StringValue;


public class ElementProperty {

	private String name;
	private String type;
	private Vector values;

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public Vector getValues() {
		return values;
	}
	public void setValues(Vector values) {
		this.values = values;
	}
	
    public String[] getStringValues() throws ValueCastException {	
    	try {
    		int size = values.size();
    		String [] array = new String[size];
    		for(int i=0; i<size; i++) {
    			array[i] = (String)values.get(i);
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getStringValues: property value cast exception");
             throw new ValueCastException("Property::getStringValues: property value cast exception");
    	}
    }
    
    public InputStream[] getBinaryValues() throws ValueCastException {
    	try {
    		int size = values.size();
    		InputStream [] array = new InputStream[size];
    		for(int i=0; i<size; i++) {
    			array[i] = (InputStream)values.get(i);
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getBinarygValues: property value cast exception");
             throw new ValueCastException("Property::getBinaryValues: property value cast exception");
    	}
    }
    
    public long[] getLongValues() throws ValueCastException {
    	try {
    		int size = values.size();
    		long [] array = new long[size];
    		for(int i=0; i<size; i++) {
    			array[i] = ((Long)values.get(i)).longValue();
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getLongValues: property value cast exception");
             throw new ValueCastException("Property::getLongValues: property value cast exception");
    	}
    }
    
    public double[] getDoubleValues() throws ValueCastException {
    	try {
    		int size = values.size();
    		double [] array = new double[size];
    		for(int i=0; i<size; i++) {
    			array[i] = ((Double)values.get(i)).doubleValue();
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getDoubleValues: property value cast exception");
             throw new ValueCastException("Property::getDoubleValues: property value cast exception");
    	}
    }
    
    public boolean[] getBooleanValues() throws ValueCastException {
    	try {
    		int size = values.size();
    		boolean [] array = new boolean[size];
    		for(int i=0; i<size; i++) {
    			array[i] = ((Boolean)values.get(i)).booleanValue();
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getBooleanValues: property value cast exception");
             throw new ValueCastException("Property::getBooleanValues: property value cast exception");
    	}
    }
    
    public Calendar[] getDateValues() throws ValueCastException {
    	try {
    		int size = values.size();
    		Calendar [] array = new Calendar[size];
    		for(int i=0; i<size; i++) {
    			array[i] = (Calendar)values.get(i);
    		}
    		return array;
    	} catch (Exception e) {
    		 TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                 "Property::getDateValues: property value cast exception");
             throw new ValueCastException("Property::getDateValues: property value cast exception");
    	}
    }

    
    
    public Value[] getJCRValues(ValueFactory vf) throws ValueCastException {
    	
    	Value[] jcrvalues = new Value[values.size()];
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_STRING)) {
    		String[] valuesStr = getStringValues();
    		for(int i=0; i<valuesStr.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesStr[i]);
    			//StringValue val = new StringValue(valuesStr[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_LONG)) {
    		long[] valuesL = getLongValues();
    		for(int i=0; i<valuesL.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesL[i]);
    			//LongValue val = new LongValue(valuesL[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_DOUBLE)) {
    		double[] valuesD = getDoubleValues();
    		for(int i=0; i<valuesD.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesD[i]);
    			//DoubleValue val = new DoubleValue(valuesD[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_BINARY)) {
    		InputStream[] valuesI = getBinaryValues();
    		for(int i=0; i<valuesI.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesI[i]);
    			//BinaryValue val = new BinaryValue(valuesI[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_BOOLEAN)) {
    		boolean[] valuesB = getBooleanValues();
    		for(int i=0; i<valuesB.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesB[i]);
    			//BooleanValue val = new BooleanValue(valuesB[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	if(type.equalsIgnoreCase(PropertiesConstants.TYPE_DATE)) {
    		Calendar[] valuesD = getDateValues();
    		for(int i=0; i<valuesD.length; i++) {
    			jcrvalues[i] = vf.createValue(valuesD[i]);
    			//DateValue val = new DateValue(valuesD[i]);
    		    //jcrvalues[i] = val;
    		}
    	}
    	return jcrvalues;
    }
    
    
}
