package it.eng.spago.cms.exec.operations;

import it.eng.spago.base.SourceBean;
import it.eng.spago.cms.exceptions.BuildOperationException;
import it.eng.spago.cms.util.constants.ModuleConstants;
import it.eng.spago.cms.util.constants.OperationsConstants;
import it.eng.spago.tracing.TracerSingleton;


 /*
 	<OPERATION name="">
  	    <GETOPERATION path="?" version="?" getVersions="(true/false)" getChilds="(true/false)" 
  	    			  getContent="(true/false)" getProperties="(true/false)" />
  	</OPERATION>
 */


public class GetOperation implements Operation {

	private SourceBean operationDescriptor = null;
	
	public GetOperation() throws BuildOperationException {	
		try {
			operationDescriptor = new SourceBean(OperationsConstants.NAME_GET_OPERATION);
			operationDescriptor.setAttribute(OperationsConstants.PATH, "");
			operationDescriptor.setAttribute(OperationsConstants.VERSION, "");
			operationDescriptor.setAttribute(OperationsConstants.GETCHILDS, "true");
			operationDescriptor.setAttribute(OperationsConstants.GETCONTENT, "true");
			operationDescriptor.setAttribute(OperationsConstants.GETPROPERTIES, "true");
			operationDescriptor.setAttribute(OperationsConstants.GETVERSIONS, "true");
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::<init>(): Error during the creation of the get operation" +
                                "SourceBean");
			throw new BuildOperationException("GetOperation::<init>(): Error during the creation of the " +
					                          "get operation SourceBean", e);
		}
	}
	
	
	public GetOperation(SourceBean descriptor){	
		operationDescriptor = descriptor;
	}
	
	public SourceBean getOperationDescriptor() {
		return operationDescriptor;
	}

	public boolean isComplete() {
		return true;
	}
	
	public void setPath(String path) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.PATH, path);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setPath: Error during the path setting");
            throw new BuildOperationException("GetOperation::setPath: Error during the path setting", e);
		}
	}
	
	public void setVersion(String ver) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.VERSION, ver);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setVersion: Error during the vversion setting");
            throw new BuildOperationException("GetOperation::setVersion: Error during the version setting", e);
		}
	}
	
	public void setRetriveVersionsInformation(String bool) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.GETVERSIONS, bool);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setRetriveVersionsInformation: Error during the getVersion setting");
            throw new BuildOperationException("GetOperation::setRetriveVersionsInformation: Error during the getVersion setting", e);
		}
	}
	
	public void setRetriveContentInformation(String bool) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.GETCONTENT, bool);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setRetriveContentInformation: Error during the getContent setting");
            throw new BuildOperationException("GetOperation::setRetriveContentInformation: Error during the getContent setting", e);
		}
	}

	
	public void setRetrivePropertiesInformation(String bool) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.GETPROPERTIES, bool);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setRetrivePropertiesInformation: Error during the getProperties setting");
            throw new BuildOperationException("GetOperation::setRetrivePropertiesInformation: Error during the getProperties setting", e);
		}
	}
	
	public void setRetriveChildsInformation(String bool) throws BuildOperationException {
		try {
			operationDescriptor.updAttribute(OperationsConstants.GETCHILDS, bool);
		} catch (Exception e) {
			TracerSingleton.log(ModuleConstants.NAME_MODULE, TracerSingleton.CRITICAL,
                                "GetOperation::setRetriveChildsInformation: Error during the getChilds setting");
            throw new BuildOperationException("GetOperation::setRetriveChildsInformation: Error during the getChilds setting", e);
		}
	}
}
