package it.eng.spago.navigation;

import it.eng.spago.navigation.NavigationException;

import java.util.ArrayList;

public class SbiNavigator {

//	// LinkedList used as stack (last-in-first-out)
//	private LinkedList list = new LinkedList();
//	
//	// Add an element to the stack
//	public void add(MarkedRequest markedRequest) {
//		list.addFirst(markedRequest);
//	}
//	
//	// Retrieves the request at the desired position and delete the later requests
//	// Index i must be 1 < i < list.size()-1, since the request at index 0 is the request for the current page
//	public MarkedRequest goBackToPosition(int i) throws Exception{
//		if (i < 1 || i > list.size()-1) throw new Exception ("Index of the required request is not correct.");
//		MarkedRequest markedRequest = (MarkedRequest) list.get(i);
//		for (int j = 0; j < i; j++) {
//			list.removeFirst();
//		}
//		return markedRequest;
//	}
//	
//	public void reset() {
//		list = new LinkedList();
//	}
//	
//	// retrieves the last request with the specified mark and delete the later requests 
//	public MarkedRequest goBackToMark(String mark) throws Exception{
//		if (mark == null) throw new Exception ("The request mark cannot be null.");
//		MarkedRequest toReturn = null;
//		int i = 1; 
//		while (i <= list.size()) {
//			MarkedRequest markedRequest = (MarkedRequest) list.get(i-1);
//			if (mark.equalsIgnoreCase(markedRequest.getMark())) {
//				toReturn = markedRequest;
//				break;
//			}
//			i++;
//		}
//		if (toReturn == null) throw new Exception ("Request with mark '" + mark + "' not found.");
//		for (int j = 0; j <= i; j++) {
//			list.removeFirst();
//		}
//		return toReturn;
//	}

	// ArrayList used as stack (last-in-first-out)
	private ArrayList list = new ArrayList();
	
	// Add an element to the stack
	public void add(MarkedRequest markedRequest) {
		list.add(0, markedRequest);
	}
	
	// Retrieves the request at the desired position and delete the later requests.
	// Index i must be 0 < i < list.size()-1, the request at index 0 is the request for the current page
	// and it is return in case of error.
	public MarkedRequest goBackToPosition(int i) throws NavigationException{
		if (i < 0 || i > list.size()-1) throw new NavigationException ("Index of the required request is not correct.");
		MarkedRequest markedRequest = (MarkedRequest) list.get(i);
		for (int j = 0; j < i; j++) {
			list.remove(0);
		}
		return markedRequest;
	}
	
	public void reset() {
		list = new ArrayList();
	}
	
	// retrieves the last request with the specified mark and delete the later requests 
	public MarkedRequest goBackToMark(String mark) throws NavigationException{
		if (mark == null) throw new NavigationException ("The request mark cannot be null.");
		MarkedRequest toReturn = null;
		int i = 1; 
		while (i <= list.size()) {
			MarkedRequest markedRequest = (MarkedRequest) list.get(i-1);
			if (mark.equalsIgnoreCase(markedRequest.getMark())) {
				toReturn = markedRequest;
				break;
			}
			i++;
		}
		if (toReturn == null) throw new NavigationException ("Request with mark '" + mark + "' not found.");
		for (int j = 0; j <= i; j++) {
			list.remove(0);
		}
		return toReturn;
	}

	public String toString () {
		String toReturn = "";
		for (int i = 0 ; i < list.size(); i++) {
			toReturn += "Position " + i + ":\n"; 
			toReturn += list.get(i).toString();
			toReturn += "\n-------------------------------------------\n";
		}
		return toReturn;
	}
}
